﻿-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

local lastUpdate=0
cfg.Update=nil
cfg.UpdateDOT=nil
local p
local spname,startTime,endTime

local phealth,phealthmax,ppower,ppowermax,ppactiveRegen,pshape
local function EnumerateTooltipLines_helper(...)
    for i = 1, select("#", ...) do
        local region = select(i, ...)
        if region and region:GetObjectType() == "FontString" then
            local text = region:GetText() -- string or nil
			text = text or " "
			print(region:GetName().." "..text)
        end
    end
end

function EnumerateTooltipLines(tooltip) -- good for script handlers that pass the tooltip as the first argument.
    EnumerateTooltipLines_helper(tooltip:GetRegions())
end

function Hedd_test(spell)
--[[	local numTabs = GetNumTalentTabs();
for t=1, numTabs do
    DEFAULT_CHAT_FRAME:AddMessage(GetTalentTabInfo(t)..":");
    local numTalents = GetNumTalents(t);
    for i=1, numTalents do
        nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(t,i);
        DEFAULT_CHAT_FRAME:AddMessage("- "..nameTalent..": "..currRank.."/"..maxRank);
    end
end]]
	
	local Hedd_Tooltip = _G["Hedd_Tooltip"] or CreateFrame('GameTooltip', 'Hedd_Tooltip', UIParent, 'GameTooltipTemplate')
	-- call this every time you want to scan
	Hedd_Tooltip:SetOwner(UIParent, 'ANCHOR_NONE')
	-- do something with the tooltip, for example set it to a player buff   
--	Hedd_Tooltip:SetUnitBuff('player', 1)
	Hedd_Tooltip:SetSpellByID(spell)
	EnumerateTooltipLines(Hedd_Tooltip)
--[[	for i=1,Hedd_Tooltip:NumLines() do
		local mytext=_G["Hedd_TooltipTextLeft"..i]
		local text=mytext:GetText()
		print(i.." "..text)
	end]]
	
	
-- get information from the tooltip, for example the buff description
	local text=Hedd_TooltipTextRight3:GetText()
	print (lib.tofloat(text))
 
-- finally hide it again
	Hedd_Tooltip:Hide()
	return text

--[[	local f = CreateFrame("Frame",nil,UIParent)
	f:SetFrameStrata("BACKGROUND")
	f:SetWidth(64) -- Set these to whatever height/width is needed 
	f:SetHeight(64) -- for your Texture

	local t = f:CreateTexture(nil,"BACKGROUND")
	--t:SetTexture("Interface\\Icons\\Ability_Shaman_Stormstrike")
	t:SetTexture(GetSpellTexture(115356))
	t:SetAllPoints(f)
	f.texture = t
	
	f:SetPoint("CENTER",0,0)
	f:Show()]]
end

local function Hedd_findclass()
	cfg.talenttree = GetSpecialization() or 4 --GetPrimarycfg.talenttree()
	if lib.classes[cfg.class] and lib.classes[cfg.class][cfg.talenttree] then
		cfg.classfound=true
		return lib.classes[cfg.class][cfg.talenttree]()
	end
	cfg.classfound=nil
	return false
end

lib.basicevents = function()
	local resetcast = function()
		cfg.casting=nil
		cfg.lastspell=nil
		cfg.lastspell2=nil
		cfg.ischanneling=nil
--		cfg.spellcast={}
		cfg.lastspell_time=nil
	end
	
	function Heddevents:ACTIONBAR_SHOW_BOTTOMLEFT(...)
		print(...)
	end
	
	function Heddevents:UNIT_POWER_FREQUENT(unit,powerType,...)
		if unit=="player" then
			ppower=cfg.power
			cfg.power=UnitPower("player")
			ppowermax=cfg.powermax
			cfg.powermax=UnitPowerMax("player")
			_,ppactiveRegen=GetPowerRegen()
			cfg.pactiveRegen=ppactiveRegen

			if cfg.power~=ppower or cfg.powermax~=ppowermax or cfg.pactiveRegen~=ppactiveRegen then
				cfg.Update=true
			end
			
			if lib.myonpower then lib.myonpower(unit,powerType) end
		end
	end
	
	function Heddevents:UNIT_HEALTH_FREQUENT(unit)
		if unit=="target" then
			phealth=cfg.health
			phealthmax=cfg.healthmax
			cfg.healthmax=UnitHealthMax("target")
			cfg.health=(cfg.healthmax==0) and 100 or hedlib.round(UnitHealth("target")*100/cfg.healthmax,0)

			if cfg.health~=phealth or  cfg.healthmax~=phealthmax then
				cfg.Update=true
			end
		end
		if lib.myonhealthupdate then lib.myonhealthupdate(unit) end
	end
	
	function Heddevents:ACTIONBAR_UPDATE_COOLDOWN()
		for index,name in pairs(cfg.spells) do
			if cfg.spells[index] and not cfg.spells[index].noupdate and lib.UpdateSpellCD(index) then cfg.Update=true end
		end
	end
	function Heddevents:ACTIONBAR_SLOT_CHANGED()
		Heddevents:ACTIONBAR_UPDATE_COOLDOWN()
	end
	
	function Heddevents:SPELL_ACTIVATION_OVERLAY_GLOW_SHOW()
		Heddevents:ACTIONBAR_UPDATE_COOLDOWN()
	end
	
	function Heddevents:ACTIONBAR_UPDATE_STATE()
		Heddevents:ACTIONBAR_UPDATE_COOLDOWN()
	end

	function Heddevents:ACTIONBAR_UPDATE_USABLE()
		Heddevents:ACTIONBAR_UPDATE_COOLDOWN()
	end

	function Heddevents:SPELL_UPDATE_USABLE()
		Heddevents:ACTIONBAR_UPDATE_COOLDOWN()
	end
	
	function Heddevents:SPELL_UPDATE_COOLDOWN()
		Heddevents:ACTIONBAR_UPDATE_COOLDOWN()
	end
	
	function Heddevents:UNIT_AURA(unitID)
--		print(unitID)
		if cfg.watchunits[unitID] and UnitExists(unitID) then
			for index,name in pairs(cfg.auras) do
				if cfg.auras[index].unit==unitID and lib.UpdateAura(index) then cfg.Update=true end
			end
			if unitID=="player" then
				Heddevents:ACTIONBAR_UPDATE_COOLDOWN()
				Heddevents:UNIT_POWER_FREQUENT(unitID)
			end
		end
		if lib.myaura then lib.myaura(unitID) end
	end
	
	function Heddevents:PLAYER_TARGET_CHANGED()
		resetcast()
		Heddevents:UNIT_AURA("target")
		lib.instance()
		lib.target()
--		cfg.targetlevel=UnitLevel("target")
		lib.ComboUpdate()
		Heddevents:UNIT_HEALTH_FREQUENT("target")
		if lib.mytarget then lib.mytarget() end
		cfg.Update=true
	end

	function Heddevents:PLAYER_REGEN_ENABLED()
		resetcast()
		if lib.nocombat then lib.nocombat() end
		cfg.Update=true
	end
	
	function Heddevents:PLAYER_EQUIPMENT_CHANGED(slot, hasItem)
		lib.UpdateEquip(slot)
		lib.UpdateSet()
		if lib.myonequip then lib.myonequip() end
	end

	function Heddevents:UNIT_SPELLCAST_START(u,spellname)
		if u=="player" then
			if cfg.debugspells then print(cfg.now.." UNIT_SPELLCAST_START "..spellname) end
			spname, _, _, _, startTime, endTime = UnitCastingInfo(u)
			if not spname then print("spell not found") return end
			cfg.casting=spname
			cfg.castStart=startTime / 1e3
			cfg.castEnd=endTime / 1e3
			if lib.onspellupdate then lib.onspellupdate() end
			cfg.Update=true
		end
	end
	
	function Heddevents:UNIT_SPELLCAST_INTERRUPTED(u,spellname)
		if u=="player" then
			if cfg.debugspells then print(cfg.now.." UNIT_SPELLCAST_INTERRUPTED "..spellname) end
			cfg.ischanneling=nil
			cfg.casting=nil
			cfg.castEnd=cfg.now
			if lib.onspellupdate then lib.onspellupdate() end
			cfg.Update=true
		end
	end
	
	function Heddevents:UNIT_SPELLCAST_DELAYED(u,spellname)
		if u=="player" then
			if cfg.debugspells then print(cfg.now.." UNIT_SPELLCAST_DELAYED "..spellname) end
			spname, _, _, _, startTime, endTime = UnitCastingInfo(u)
			if not spname then print("spell not found") return end
--			if not startTime then return end
			cfg.casting=spname
			cfg.castStart=startTime / 1e3
			cfg.castEnd=endTime / 1e3
			if lib.onspellupdate then lib.onspellupdate() end
			cfg.Update=true
		end
	end
	
--[[	function Heddevents:UNIT_SPELLCAST_STOP(u,spellname)
		if u=="player" then
			if cfg.debugspells then print(cfg.now.." UNIT_SPELLCAST_STOP "..spellname) end
			cfg.casting=nil
			cfg.castEnd=cfg.now
			cfg.Update=true
		end
	end]]

--[[	function Heddevents:UNIT_SPELLCAST_FAILED(u,spellname)
		if u=="player" then
			if cfg.debugspells then print(cfg.now.." UNIT_SPELLCAST_FAILED "..spellname) end
			cfg.casting=nil
			cfg.castEnd=cfg.now
			cfg.Update=true
		end
	end]]
	
	function Heddevents:UNIT_SPELLCAST_SUCCEEDED(u,spellname)
		if u=="player" and not cfg.res_spells[spellname] then
			if cfg.debugspells then print(cfg.now.." UNIT_SPELLCAST_SUCCEEDED "..spellname) end
			if cfg.ischanneling and cfg.showchannel then
				Heddevents:UNIT_SPELLCAST_CHANNEL_START(u,spellname)
			else
--				print(cfg.now.." UNIT_SPELLCAST_SUCCEEDED "..spellname)
				cfg.casting=nil
				cfg.castEnd=cfg.now
				cfg.ischanneling=nil
				lib.SaveSpell(spellname)
				if lib.onspellupdate then lib.onspellupdate() end
				cfg.Update=true
			end
		end
	end

	function Heddevents:UNIT_SPELLCAST_CHANNEL_START(u,spellname)
		if u=="player" and cfg.showchannel then
			if cfg.debugspells then print(cfg.now.." UNIT_SPELLCAST_CHANNEL_START "..spellname) end
			spname, _, _, _, startTime, endTime = UnitChannelInfo(u)
			if not spname then print("spell not found") return end
			cfg.ischanneling=true
			cfg.casting=spname
			cfg.castStart=startTime / 1e3
			cfg.castEnd=endTime / 1e3
			if lib.onspellupdate then lib.onspellupdate() end
			cfg.Update=true
		end
	end
	
	function Heddevents:UNIT_SPELLCAST_CHANNEL_UPDATE(u,spellname)
		if u=="player" and cfg.showchannel then
			if cfg.debugspells then print(cfg.now.." UNIT_SPELLCAST_CHANNEL_UPDATE "..spellname) end
			spname, _, _, _, startTime, endTime = UnitChannelInfo(u)
			if not spname then print("spell not found") return end
			cfg.ischanneling=true
			cfg.casting=spname
			cfg.castStart=startTime / 1e3
			cfg.castEnd=endTime / 1e3
			if lib.onspellupdate then lib.onspellupdate() end
			cfg.Update=true
		end
	end
	
	function Heddevents:UNIT_SPELLCAST_CHANNEL_STOP(u,spellname)
		if u=="player" and cfg.showchannel then
			if cfg.debugspells then print(cfg.now.." UNIT_SPELLCAST_CHANNEL_STOP "..spellname) end
			cfg.ischanneling=nil
			cfg.casting=nil
			cfg.castEnd=cfg.now
			lib.SaveSpell(spellname)
			if lib.onspellupdate then lib.onspellupdate() end
			cfg.Update=true
		end
	end
	
	function Heddevents:COMBAT_LOG_EVENT_UNFILTERED(timeStamp, eventtype,_,sourceGUID,sourceName,_,_,destGUID,destName,_,_,spellId,spellName,_,_,interrupt)
	if cfg.TrackDOT then
		if eventtype == "SPELL_AURA_APPLIED" or eventtype == "SPELL_AURA_REFRESH" or eventtype == "SPELL_PERIODIC_DAMAGE" or eventtype == "SPELL_PERIODIC_HEAL" then
			if spellId == cfg.auras[cfg.TrackDOT].id then
				if sourceGUID == UnitGUID("player") then
					-- print (timeStamp.." "..eventtype.." "..destGUID.." "..spellName)
					lib.AddDOT(destGUID)
					if eventtype == "SPELL_AURA_REFRESH" and lib.CL_SPELL_AURA_REFRESH then lib.CL_SPELL_AURA_REFRESH(spellId,destGUID) end
				end
			end
		end
		if eventtype == "SPELL_AURA_REMOVED" then
			if spellId == cfg.auras[cfg.TrackDOT].id then
				if sourceGUID == UnitGUID("player") then
					lib.DelDOT(destGUID)
				end
			end
		end
		if eventtype == "UNIT_DIED" or eventtype == "UNIT_DESTROYED"  then
			lib.DelDOT(destGUID)
		end
	end
	
	if lib.CL_Spell then
		if eventtype == "SPELL_CAST_SUCCESS" then
			if sourceGUID == UnitGUID("player") then
				--print (timeStamp.." "..eventtype.." "..destGUID.." "..spellName)
				cfg.Update=lib.CL_Spell(spellId,destGUID)
			end
		end
	end

end


--[[	function Heddevents:UPDATE_SHAPESHIFT_FORM(...)
		pshape=cfg.shape
		cfg.shape=lib.shape()
		
		if cfg.shape~=pshape then
			if lib.onshapeupdate then lib.onshapeupdate() end
			cfg.Update=true
		end
	end]]
	
	function Heddevents:PLAYER_ENTERING_WORLD()
		Heddevents:ACTIONBAR_UPDATE_COOLDOWN()
		Heddevents:PLAYER_TARGET_CHANGED()
		Heddevents:UNIT_AURA("player")
		Heddevents:UNIT_POWER_FREQUENT("player")
		cfg.shape=lib.shape()
--		lib.instance()
		
		if lib.mypew then
			lib.mypew()
		end
		cfg.Update=true
	end
end

local function Hedd_onupdate(self, elapsed)
	lastUpdate = lastUpdate + elapsed
	cfg.now = GetTime()
	if cfg.Update or lastUpdate > cfg.UpdateTime then --or lib.SpellCasting()

		if lib.myonupdate then
			lib.myonupdate()
		end
		
		if lib.rangecheck then
			lib.rangecheck()
		end
		
		if cfg.Update then lib.SetPriority() end
	
		Heddframe.text:SetText(cfg.mode)
		
		if cfg.TrackBUFF then 
			lib.UpdateBUFF()
		end
		lastUpdate = 0
		cfg.Update=nil
	end
end

function Heddtal_onevent(self,event)
--	if event then print(event) end
	if event=="UPDATE_SHAPESHIFT_FORM" then
		local pshape=cfg.shape
		cfg.shape=lib.shape()
		if cfg.shape==pshape then return end
--		print(cfg.shape)
	end
		
	for index,name in pairs(cfg.spells) do
		lib.HideFrame(cfg.spells[index].f)
	end
	Heddframe.text:Hide()
	Heddframe:Hide()
	
	lib.defaults()
	
	Heddframe:UnregisterAllEvents()
	Heddframe:SetScript("OnEvent",nil)
	Heddframe:SetScript("OnUpdate",nil)
	if Hedd_findclass() then
		lib.basicevents()

		if lib.classevents[cfg.class] then lib.classevents[cfg.class]() end
		
		cfg.shape=lib.shape()
		
		cfg.case["end"] = function ()
			if cfg.cmintime~=cfg.maxmintime then return nil end
			lib.UpdateBar(nil)
			return true
		end
		
		lib.UpdateEquipAll()
--		if lib.myonequip then lib.myonequip() end
		
		cfg.numcase=0
		for key, value in pairs(cfg.plist) do
			cfg.numcase=cfg.numcase+1
		end
		cfg.numcase=cfg.numcase+1
		
		Heddframe:SetScript("OnEvent", function(cframe, cevent, ...)
			if not cfg.classfound then return end
--			print(cevent)
			Heddevents[cevent](_,...)--_,
		end)

		for k, v in pairs(Heddevents) do
			Heddframe:RegisterEvent(k)
		end
		
		Heddframe:SetScript("OnUpdate", Hedd_onupdate)
		
		if cfg.TrackDOT then
			Heddframe.DOT:SetScript("OnUpdate", lib.OnUpdateDOT)
			Heddframe.DOT:Show()
		else
			Heddframe.DOT:SetScript("OnUpdate", nil)
			Heddframe.DOT:Hide()
		end
		
		if lib.mytal then
			lib.mytal()
		end
		
		
		
		Heddevents:PLAYER_ENTERING_WORLD()
		Heddframe:Show()
		Heddframe.text:Show()
		lib.AddSpell("hs",{8690}) --Hearthstone
	end
	
end

cfg.notloaded=true
local function Heddframe_pew(self,...)
	if cfg.notloaded then 
		cfg.notloaded=nil
		Heddframe:UnregisterEvent("SPELLS_CHANGED")
		Heddframe:RegisterForClicks("AnyUp")
		Heddframe:SetScript("OnClick", function (self, button, down)
		if lib.onclick then lib.onclick() end
		end);

		Heddtalents:SetScript("OnEvent",Heddtal_onevent)
		Heddtalents:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
		Heddtalents:RegisterEvent("CHARACTER_POINTS_CHANGED")
		Heddtalents:RegisterEvent("PLAYER_TALENT_UPDATE")
		Heddtalents:RegisterEvent("UPDATE_SHAPESHIFT_FORM")
		Heddtalents:RegisterEvent("SPELLS_CHANGED")
		Heddtal_onevent()
		-- Hedd_test()
	end
end


Heddframe:SetScript("OnEvent",Heddframe_pew)
--Heddframe:RegisterEvent("PLAYER_ENTERING_WORLD")
Heddframe:RegisterEvent("SPELLS_CHANGED")